MODULE testcse16 ;

CONST
   MaxScopes  =  20 ; (* Maximum number of scopes at any one time.           *)
   NulSym     =   0 ;

TYPE
   CallFrame = RECORD
                  Main  : CARDINAL ;  (* Main scope for insertions        *)
                  Search: CARDINAL ;  (* Search scope for symbol searches *)
                  Start : CARDINAL ;  (* ScopePtr value before StartScope *)
                                      (* was called.                      *)
               END ;

VAR
   ScopeCallFrame: ARRAY [1..MaxScopes] OF CallFrame ;
   ScopePtr      : CARDINAL ;


PROCEDURE foo (Sym: CARDINAL) ;
BEGIN
   INC(ScopePtr) ;
   WITH ScopeCallFrame[ScopePtr] DO
      Main := ScopeCallFrame[ScopePtr-1].Main ;
      Start := ScopeCallFrame[ScopePtr-1].Start ;
      Search := Sym
   END
END foo ;


PROCEDURE IsAlreadyDeclaredSym (Name: CARDINAL) : BOOLEAN ;
BEGIN
   WITH ScopeCallFrame[ScopePtr] DO
      RETURN( GetLocalSym(ScopeCallFrame[ScopePtr].Main, Name)#NulSym )
   END
END IsAlreadyDeclaredSym ;


PROCEDURE GetLocalSym (Sym: CARDINAL; Name: CARDINAL) : CARDINAL ;
BEGIN
   RETURN( 0 )
END GetLocalSym ;


BEGIN
   foo(1) ;
   IF IsAlreadyDeclaredSym(1234)
   THEN
   END
END testcse16.
