MODULE testcse31 ;

FROM SYSTEM IMPORT ADDRESS, PROCESS, LISTEN, OnOrOff, TurnInterrupts,
                   NEWPROCESS, TRANSFER, IOTRANSFER ;

TYPE
   DESCRIPTOR= POINTER TO Descriptor ;        (* handle onto a process         *)
   Descriptor= RECORD
                  Volatiles  : PROCESS ;      (* process volatile environment  *)
               END ;


PROCEDURE Reschedule ; (* (VAR From, Highest: DESCRIPTOR) ; *)
VAR From, Highest: DESCRIPTOR ;
BEGIN
   Highest := NIL ;
   IF From#CurrentProcess
   THEN
      From := CurrentProcess ;
      CurrentProcess := Highest ;
      TRANSFER(From^.Volatiles, Highest^.Volatiles)
   END
END Reschedule ;


VAR
   CurrentProcess: DESCRIPTOR ;
BEGIN
   Reschedule ; (* (CurrentProcess, CurrentProcess) ; *)
   CurrentProcess := NIL
END testcse31.
